'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactAddonsUpdate = require('react-addons-update');

var _reactAddonsUpdate2 = _interopRequireDefault(_reactAddonsUpdate);

var _classnames3 = require('classnames');

var _classnames4 = _interopRequireDefault(_classnames3);

var _uniqueId = require('lodash/uniqueId');

var _uniqueId2 = _interopRequireDefault(_uniqueId);

var _isRegExp = require('lodash/isRegExp');

var _isRegExp2 = _interopRequireDefault(_isRegExp);

var _isFunction = require('lodash/isFunction');

var _isFunction2 = _interopRequireDefault(_isFunction);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } // npm dependencies
//


// @TODO permitted characters regex

/**
 * The TextInput component
 *
 */
var TextInput = function (_React$Component) {
    _inherits(TextInput, _React$Component);

    /**
     * Construct the component instance
     * @param  {Object} props The component props
     */
    function TextInput(props) {
        _classCallCheck(this, TextInput);

        // format the value if we have a format method
        //
        var _this = _possibleConstructorReturn(this, (TextInput.__proto__ || Object.getPrototypeOf(TextInput)).call(this, props));

        var value = props.format ? props.format(props.value) : props.value;

        // initialize the state for the component
        //
        _this.state = {
            value: value,
            isValid: true,
            validationError: null,
            isEditing: false
        };

        // generate a unique ID for this component instance
        //
        _this.id = props.id || (0, _uniqueId2.default)('form-textinput-');

        // intialize the validation message for the component
        //
        var required = _this.props.description + ' is required';
        if (props.validationMessage) {
            required = '' + (props.validationMessage.required || props.validationMessage);
        }

        var valid = _this.props.description + ' is not valid';
        if (props.validationMessage) {
            valid = '' + (props.validationMessage.valid || props.validationMessage);
        }

        // initialize the validation messages for the component
        //
        _this.validationMessage = { required: required, valid: valid };

        // bind `this` to the component event handlers
        //
        _this.onBlur = _this.onBlur.bind(_this);
        _this.onFocus = _this.onFocus.bind(_this);
        _this.onChange = _this.onChange.bind(_this);
        return _this;
    }

    /**
     * Handle the "component is about to mount" event
     */


    _createClass(TextInput, [{
        key: 'componentWillMount',
        value: function componentWillMount() {
            // determine if it's valid
            //
            var _validate = this.validate(this.state.value);

            var validationError = _validate.validationError;

            // set the new validationError state
            //

            this.setState((0, _reactAddonsUpdate2.default)(this.state, { validationError: { $set: validationError } }));

            // call the `onChildValidationEvent` handler once with
            // `hasValidated`=false, just to ensure that the parent knows about this
            // child
            //
            if (this.context.onChildValidationEvent) {
                this.context.onChildValidationEvent(this.id, false, validationError);
            }
        }

        /**
         * Handle new props received from parent components
         * @param  {Object} newProps The new properties for the component
         */

    }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(newProps) {
            var _this2 = this;

            // update the new required prop (if it's changing)
            //
            this.setState(function (state) {
                return (0, _reactAddonsUpdate2.default)(state, {
                    required: { $set: newProps.required }
                });
            }, function () {
                // get the value from the new props
                //
                var value = newProps.value;

                // figure out the formatted value
                //
                var formattedValue = _this2.props.format ? _this2.props.format(value) : value;

                var oldValue = _this2.state.value;
                var oldValidationError = _this2.state.validationError;

                // determine if it's valid
                //

                var _validate2 = _this2.validate(formattedValue);

                var isValid = _validate2.isValid;
                var validationError = _validate2.validationError;

                // update the component state if
                // a) we're currently editing and the value is subject to formatting, or
                // b) we have a brand new value
                //

                if (oldValidationError !== validationError || oldValue !== value) {
                    _this2.setState(function (state) {
                        return (0, _reactAddonsUpdate2.default)(state, {
                            value: { $set: value },
                            isValid: { $set: isValid },
                            validationError: { $set: validationError }
                        });
                    }, function () {
                        // call the `onChildValidationEvent` handler
                        //
                        if (_this2.context.onChildValidationEvent) {
                            _this2.context.onChildValidationEvent(_this2.id, true, validationError);
                        }
                    });
                }
            });
        }

        /**
         * Handle the blur event for the input element
         * @param  {Object} event The event object
         */

    }, {
        key: 'onBlur',
        value: function onBlur() {
            // get the value
            //
            var value = this.state.value;

            // get the formatted value
            //
            var formattedValue = this.props.format ? this.props.format(value) : value;

            // determine if it's valid
            //

            var _validate3 = this.validate(formattedValue);

            var isValid = _validate3.isValid;
            var validationError = _validate3.validationError;

            // set the `isValid` state
            //

            this.setState(function () {
                return {
                    value: formattedValue,
                    isValid: isValid,
                    validationError: validationError,
                    isEditing: false
                };
            });

            // call the `onChildValidationEvent` handler
            //
            if (this.context.onChildValidationEvent) {
                this.context.onChildValidationEvent(this.id, true, validationError);
            }

            // call the `onChange` handler
            //
            if (this.props.onChange) {
                this.props.onChange(formattedValue);
            }
        }

        /**
         * Handle the `onFocus` event
         */

    }, {
        key: 'onFocus',
        value: function onFocus() {
            var _this3 = this;

            // do we have a parse prop? is the component NOT read only?
            //
            if (this.props.parse && !this.props.readOnly) {
                // yes! parse the value before editing begins
                //
                this.setState(function (state) {
                    return (0, _reactAddonsUpdate2.default)(state, {
                        value: { $set: _this3.props.parse(_this3.state.value) },
                        isEditing: { $set: true }
                    });
                });
            }
        }

        /**
         * Handle the change event for the input element
         * @param  {Object} event The event object
         */

    }, {
        key: 'onChange',
        value: function onChange(event) {
            // get the value from the event object
            //
            var value = event.target.value;

            // update the component state
            //
            this.setState(function (state) {
                return (0, _reactAddonsUpdate2.default)(state, {
                    value: { $set: value },
                    isEditing: { $set: true }
                });
            });

            // do we have an `onChange` handler? if so call it with the new value
            //
            if (this.props.onChange) {
                this.props.onChange(value);
            }
        }

        /**
         * Validate a value
         * @param  {String} value The value to validate
         * @return {Boolean}      True if the value is valid, false otherwise
         */

    }, {
        key: 'validate',
        value: function validate(value) {
            // declare a variable to hold the result
            //
            var isValid = true;

            var validationError = null;

            // do we have a value?
            //
            if (!value) {
                // we do not have a value - in this case, whether it's valid or not
                // is determined solely by whether a valid is required or not
                //
                isValid = !this.props.required;

                validationError = isValid ? null : this.validationMessage.required;
            } else {
                // we do have a value. Do we have a pattern prop?
                //
                if (this.props.pattern) {
                    // yes, we have a pattern prop. is the pattern a regex or is it
                    // a function?
                    //
                    if ((0, _isRegExp2.default)(this.props.pattern)) {
                        // the pattern is a regex. Test the value against it
                        //
                        isValid = this.props.pattern.test('' + value);
                        validationError = isValid ? null : this.validationMessage.valid;
                    } else if ((0, _isFunction2.default)(this.props.pattern)) {
                        // the pattern is a function. Pass the value to the function
                        //
                        isValid = this.props.pattern(value);
                        validationError = isValid ? null : this.validationMessage.valid;
                    }
                } else {
                    // we don't have a pattern prop. That means if we get here that
                    // we have a value and it doesn't matter whether it's required
                    // or not because we have a value
                    //
                    isValid = true;
                    validationError = null;
                }
            }

            // return the results of the validation
            //
            return { isValid: isValid, validationError: validationError };
        }

        /**
         * Render the component
         * @return {React.Element} The React element describing the component
         */

    }, {
        key: 'render',
        value: function render() {
            // is the component hidden? if so, return null
            //
            if (this.props.hidden) {
                return null;
            }

            // render the label for the component, if we have one
            //
            var labelStyles = this.props.inline ? { marginRight: '1em' } : {};

            // instantiate the label element
            //
            var label = this.props.label ? _react2.default.createElement(
                'label',
                {
                    htmlFor: this.id,
                    className: (0, _classnames4.default)(_defineProperty({
                        'control-label': !this.props.inline
                    }, 'col-xs-' + this.context.labelColumns, !this.props.inline && this.context.labelColumns)),
                    style: labelStyles
                },
                this.props.label,
                this.props.required ? _react2.default.createElement(
                    'sup',
                    null,
                    ' ',
                    _react2.default.createElement('i', { className: 'required fa fa-star' })
                ) : ''
            ) : null;

            // render the help block (validation error message) if appropriate
            //
            var helpBlock = !this.state.isValid ? _react2.default.createElement(
                'span',
                { className: 'help-block' },
                this.state.validationError
            ) : null;

            // initialize the styles for the input element
            //
            var inputStyles = this.props.inline && this.props.inlineWidth ? { width: this.props.inlineWidth } : {};

            // render the input component
            //
            var input = _react2.default.createElement('input', {
                type: this.props.password ? 'password' : 'text',
                readOnly: !!this.props.readOnly,
                id: this.id,
                name: this.props.name,
                value: this.state.value,
                placeholder: this.props.placeholder,
                className: 'form-control',
                style: inputStyles,
                onBlur: this.onBlur,
                onFocus: this.onFocus,
                onChange: this.onChange
            });

            // is this an inline text input? if not, wrap it in a div
            //
            if (!this.props.inline) {
                input = _react2.default.createElement(
                    'div',
                    {
                        className: (0, _classnames4.default)('form-textinput-input-columns', _defineProperty({}, 'col-xs-' + (12 - this.context.labelColumns), this.context.labelColumns))
                    },
                    input,
                    helpBlock
                );
            }

            // return the rendered component
            //
            return this.props.inline ? _react2.default.createElement(
                'div',
                {
                    className: 'form-inline',
                    style: {
                        display: 'inline-block',
                        marginRight: '1em'
                    }
                },
                _react2.default.createElement(
                    'div',
                    { className: (0, _classnames4.default)('form-group', { 'has-error': !this.state.isValid }) },
                    label,
                    input,
                    helpBlock
                )
            ) : _react2.default.createElement(
                'div',
                { className: (0, _classnames4.default)('form-group', { 'has-error': !this.state.isValid }) },
                label,
                input
            );
        }
    }]);

    return TextInput;
}(_react2.default.Component);

/**
 * The property types for the component
 * @type {Object}
 */


TextInput.propTypes = {
    /** The name for the component */
    name: _react2.default.PropTypes.string,
    /** The ID for the component */
    id: _react2.default.PropTypes.string,
    /** A flag to indicate whether this is a password input component */
    password: _react2.default.PropTypes.bool,
    /** A flag to indicate whether this component is required */
    required: _react2.default.PropTypes.bool,
    /** A flag to indicate whether this component is read only */
    readOnly: _react2.default.PropTypes.bool,
    /** A flag to indicate whether this component is hidden */
    hidden: _react2.default.PropTypes.bool,
    /** A flag to indicate whether this component is to be rendered inline */
    inline: _react2.default.PropTypes.bool,
    /** The width of the component if rendering inline */
    inlineWidth: _react2.default.PropTypes.string,
    /** The value of the text input component */
    value: _react2.default.PropTypes.oneOfType([_react2.default.PropTypes.string, _react2.default.PropTypes.number]),
    /** The label for the component */
    label: _react2.default.PropTypes.string,
    /** The placeholder for the component */
    placeholder: _react2.default.PropTypes.string,
    /** The description for the component (used in validation error messages) */
    description: _react2.default.PropTypes.string,
    /** A custom validation message, or set of messages */
    validationMessage: _react2.default.PropTypes.oneOfType([_react2.default.PropTypes.string, _react2.default.PropTypes.object]),
    /** A regex used to validate values */
    pattern: function pattern(props, propName, componentName) {
        if (props.pattern && !(0, _isRegExp2.default)(props.pattern) && !(0, _isFunction2.default)(props.pattern)) {
            return new Error('Invalid prop ' + propName + ' supplied to ' + componentName + ' - should be a regular expression');
        }
        return null;
    },
    /**
     * A function used to format the value
     *
     * Note that if you are using a `format` function, the value should be
     * formatted **before** passing it as a property; if you fail to do this,
     * then the user will initially see an unformatted value which will be
     * formatted after the first edit.
    */
    format: _react2.default.PropTypes.func,
    /**
     * A function used to parse the value which has been formatted by the
     * `format` function
     */
    parse: _react2.default.PropTypes.func,
    /** The `onChange` handler for the component */
    onChange: _react2.default.PropTypes.func,
    /**
     * The key used to identify this component by the parent Form component for
     * tracking validation errors in Form children
     */
    validationKey: _react2.default.PropTypes.string
};

/**
 * The context types for the component
 * @type {Object}
 */
TextInput.contextTypes = {
    onChildValidationEvent: _react2.default.PropTypes.func,
    labelColumns: _react2.default.PropTypes.number
};

// export the component
//
exports.default = TextInput;